UNIT uBetrieb;

(* ******************************************************************** *)
(*                                                                      *)
(* K L A S S E : TBetrieb                                               *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.0                                                    *)
(* Autor       : S. Spolwig, OSZ-Handel I, 10997 Berlin                 *)
(*                                                                      *)
(* Aufgabe     : verwaltet das Objekt Betrieb in e-fish.                *)
(*                                                                      *)
(* Compiler    : DELPHI 4.0                                             *)
(* Aenderung   : V. 1.0   20-OCT-00                                     *)
(* ******************************************************************** *)

INTERFACE
(* ========================== Export ================================== *)
USES Classes;

type
  TBetrieb = class (TObject)
   private
    Nummer      : Word;
    Name : string[25];

    public
    constructor Create;
    procedure   Init;                        virtual;
    procedure   SetNummer (n: Word);         virtual;
    procedure   SetName (bz: string);        virtual;

    function GetNummer : Word;               virtual;
    function GetName : string;               virtual;

    procedure InDateiSchreiben (var fs : TFilestream); virtual;
    procedure AusDateiLesen    (var fs : TFilestream); virtual;
  end; (* TBetrieb *)

(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse     : -
Bezugsklassen  : Classes import: TFilestream, read write



Methoden
--------

Create
  Auftrag: Betrieb erzeugen und Initialisieren
  vorher : -
  nachher: Betrieb ist erzeugt,alle Datenfelder sind leer.

Init
  Auftrag: Betrieb Initialisieren
  vorher : ist erzeugt
  nachher: alle Datenfelder sind leer.

Set...
  Auftrag: Attribut schreiben
  vorher : Betrieb ist vorhanden.
  nachher: Attribut ist gesetzt

Get...
  Anfrage: Attribut aus dem Objekt lesen
  vorher : Person ist vorhanden.
  nachher: -


InDateiSchreiben (var fs : TFilestream)
  Auftrag: Attribute auf die Festplatte speichern
  vorher : fs ist geffnet
  nachher: Attribute sind an fs uebergeben


AusDateiLesen (var fs : TFilestream)
  Auftrag: Attribute von der Festplatte laden
  vorher : fs ist geffnet
  nachher: Attribute sind an Betrieb uebergeben
----------------------------------------------------------------------- *)

IMPLEMENTATION
(* ==================================================================== *)

constructor TBetrieb.Create;
(* -------------------------------------------------------------------- *)
begin
  inherited Create;
  Init;
end;

procedure TBetrieb.Init;
(* -------------------------------------------------------------------- *)
begin
  Nummer       := 0;
  Name    := '';
end;

procedure TBetrieb.SetNummer (n: Word);
(* -------------------------------------------------------------------- *)
begin
  Nummer := n;
end;


procedure TBetrieb.SetName (bz: string);
(* -------------------------------------------------------------------- *)
begin
  Name := bz;
end;


function TBetrieb.GetNummer : Word;
(* -------------------------------------------------------------------- *)
begin
  result := Nummer;
end;


function TBetrieb.GetName : string;
(* -------------------------------------------------------------------- *)
begin
  result := Name;
end;


procedure TBetrieb.InDateiSchreiben (var Fs : TFileStream);
(* -------------------------------------------------------------------- *)
begin
  Fs.write(Nummer, sizeof(Nummer));
  Fs.write(Name, sizeof(Name));
end;


procedure TBetrieb.AusDateiLesen (var Fs : TFileStream) ;
(* -------------------------------------------------------------------- *)
begin
  Fs.read(Nummer, sizeoF(Nummer));
  Fs.read(Name, sizeoF(Name));
end;


END.
