UNIT uDListe;
(* ******************************************************************** *)
(*                                                                      *)
(* K L A S S E   : TListe - (Teil-)abstrakte Klasse                     *)
(* -------------------------------------------------------------------- *)
(* Version       : 2.01                                                 *)
(* Autor         : (c) S. Spolwig, OSZ-Handel I, 10997 Berlin           *)
(*                                                                      *)
(* Aufgabe       : Allgemeine dynamische Liste zur Verwaltung beliebiger*)
(*                 Objekte.                                             *)
(*                 uDListe ist schnittstellen-kompatibel mit uSListe.   *)
(*                                                                      *)
(* Compiler      : Delphi 4.0                                           *)
(* Aenderung     : 2.01	- 13-OKT-00 	IsFull entfernt                   *)
(* ******************************************************************** *)

INTERFACE
(* ==================================================================== *)
type
  TListe  = class (TObject)
    protected
    Kollektion  : array of Pointer;
    LiLaenge,                 // Anzahl der belegten Elemente
    AktuellePos : integer;    // auf aktivem Element oder EoList

    public
    constructor Create;  virtual;
    procedure Init;      virtual;
    procedure First;     virtual;
    procedure Next ;     virtual;
    procedure previous;  virtual;
    procedure Last ;     virtual;

    function  GetElement: pointer;           virtual;
    procedure PutElement (Elem : pointer);   virtual;
    procedure Append (Elem : pointer);       virtual;
    procedure Remove;                        virtual;
    procedure RemoveAll;                     virtual;
    function  GetLen  : integer ;            virtual;
    function  GetAktuellePos : integer;      virtual;
    function  EoList  : boolean;             virtual;
    function  IsFirst : boolean;             virtual;
    function  IsLast  : boolean;             virtual;
    function  IsEmpty : boolean;             virtual;
    function  SearchElement (suchElem : pointer) : pointer; virtual; //abstrakt
    procedure Load (Dateiname : string);     virtual;   //abstrakt
    procedure Store(Dateiname : string);     virtual;   //abstrakt
  end;



IMPLEMENTATION
(* ==================================================================== *)

constructor TListe.Create;
(* -------------------------------------------------------------------- *)
begin
  inherited Create;
  Init;
end;


procedure TListe.Init;
(* -------------------------------------------------------------------- *)
var i : integer;
begin
  Kollektion := NIL;
  setlength(kollektion,2);
  for i := 0 to 1 do
  begin
    Kollektion[i] := NIL;
  end;
  Lilaenge    := 0;
  AktuellePos := 0;
end;


procedure TListe.First;
(* -------------------------------------------------------------------- *)
begin
  If NOT IsEmpty
  then AktuellePos := 1;
end;


procedure TListe.Next;
(* -------------------------------------------------------------------- *)
Begin
  if NOT (EoList)
  then AktuellePos := AktuellePos + 1;
end;


procedure TListe.Previous;
(* -------------------------------------------------------------------- *)
begin
  if NOT (IsEmpty or IsFirst)
  then AktuellePos := AktuellePos - 1;
end;


procedure TListe.Last;
(* -------------------------------------------------------------------- *)
begin
  AktuellePos := Lilaenge ;
end;


function TListe.GetElement : pointer;
(* -------------------------------------------------------------------- *)
begin
  Result := Kollektion[AktuellePos];
end;


procedure TListe.PutElement (Elem : pointer);
(* -------------------------------------------------------------------- *)
begin
  Kollektion[AktuellePos] := Elem;
end;


procedure TListe.Append (Elem : pointer);
(* -------------------------------------------------------------------- *)
begin
  if IsEmpty
  then AktuellePos := 1
  else
   begin
     Last;
     next;
   end;

   PutElement(Elem);
   inc (Lilaenge);
   setlength(kollektion,lilaenge + 2);
   kollektion[high(kollektion)] := NIL;
end;


procedure TListe.Remove;
(* -------------------------------------------------------------------- *)
var
  i    : Cardinal;

begin
  if NOT IsEmpty
  then
    begin
      for i := aktuellepos to lilaenge do
        Kollektion[i] := Kollektion[i+1];

      dec(LiLaenge);
      Setlength(Kollektion,lilaenge+ 2);
      First;
    end;
end;  (* remove *)


procedure TListe.RemoveAll;
(* -------------------------------------------------------------------- *)
begin
  if NOT IsEmpty
  then Init;
end;


function TListe.GetLen : integer ;
(* -------------------------------------------------------------------- *)
begin
  Result := Lilaenge;
end;


function TListe.GetAktuellePos : integer;
(* -------------------------------------------------------------------- *)
begin
  Result := AktuellePos;
end;


function TListe.EoList : boolean;
(* -------------------------------------------------------------------- *)
begin
  if Kollektion[AktuellePos] = NIL
  then Result := true
  else Result := false;
end;


function TListe.IsFirst : boolean;
(* -------------------------------------------------------------------- *)
begin
  if AktuellePos = 1
  then Result := true
  else Result := false;
end;


function TListe.IsLast : boolean;
(* -------------------------------------------------------------------- *)
begin
  if AktuellePos = LiLaenge
  then Result := true
  else Result := false;
end;


function TListe.IsEmpty : boolean ;
(* -------------------------------------------------------------------- *)
begin
  Result := false;
  if LiLaenge = 0
  then Result := true;
end;


function  TListe.SearchElement (suchElem : pointer) : pointer;
(* -------------------------------------------------------------------- *)
begin
  result := NIL;
end;


procedure TListe.Load (Dateiname : string);
(* -------------------------------------------------------------------- *)
begin
end;


procedure TListe.Store(Dateiname : string);
(* -------------------------------------------------------------------- *)
begin
end;

END.
