unit uWoche;
(* ******************************************************************** *)
(*                                                                      *)
(* K L A S S E : TWoche                                                 *)
(* -------------------------------------------------------------------- *)
(* Version     : 1.0                                                    *)
(* Autor       : Norman Niemer                                          *)
(*                                                                      *)
(* Aufgabe     : verwaltet alle Tag der Woche                           *)
(*                                                                      *)
(* Compiler    : DELPHI 4.0                                             *)
(* Aenderung   : 26.12.00 Anfang
(* ******************************************************************** *)

interface

uses uMitarbeiter, uMAListe, uPool, uSchicht, uTag;

const End_Frueh = 13;
      End_Spaet = 26;

type
  TWoche = class(TObject)
       private
         Wochennummer : integer;
         pool : TPool;
       public
         tage : array[1..6] of TTag;

         constructor Create(wnr : integer; ap : string; EndeFS: integer; EndeSS: integer );
         destructor Free;

         function Besetzen(MAListe : TMAListe):boolean;
         procedure NeuerArbeitsplatz(Arbeitsplatz : string; EndeFS: integer; EndeSS: integer );
  end; (*TWoche*)

implementation

constructor TWoche.Create;
(* ------------------------------------------------------------------------ *)
var tag : TTAg;
    i : integer;
begin
     wochennummer := wnr;
     for i:= 1 to 6 do
     begin
     tag := TTag.Create(i,'1.1.00', ap, EndeFS, EndeSS);       // Datum ist egal
     tage[i] := tag;
     end;

     pool := TPool.Create;
end;

destructor TWoche.Free;
(* ------------------------------------------------------------------------ *)
var i : integer;
begin
     for i:= 1 to 6 do
     tage[i].Free;
end;

function TWoche.Besetzen;
(* ------------------------------------------------------------------------ *)
var i : integer;
    ma : TMitarbeiter;
begin
      result := true;
      ma := TMitarbeiter.Create;
      maliste.First;
      for i := 1 to maliste.getlen do
      begin
           ma:= maliste.getelement;
           ma.setalletagefrei;
           ma.setiststunden(0);
           maliste.next;
      end;

      i := 1;

      while i <= 6 do
      begin
           if not tage[i].Besetzen(maliste) then result := false;
           inc(i);
      end;
end;

procedure TWoche.NeuerArbeitsplatz;
(* ------------------------------------------------------------------------ *)
var i : integer;
begin
      for i:= 1 to 6 do
          tage[i].NeuerArbeitsplatz(arbeitsplatz, EndeFS, EndeSS);
end;

end.
