unit ufenster;

(* ******************************************************************** *)
(* K L A S S E :  FENSTER                                               *)
(* -------------------------------------------------------------------- *)
(* Version     :  4.X                                                   *)
(* Autor       :  Michael Nicolai, Marten Knoch, Norman Niemer          *)
(*                                                                      *)
(* Aufgabe     : uebernimmt E/A und steuert die Funktionen zur Patien-  *)
(*               tenverwaltung ber ein GUI                             *)
(* Compiler    : DELPHI 4.0                                             *)
(* nderungen  : 2.1.00 NN: NeuBtn, ndernBtn, Einsatzplanaktualisieren *)
(* ******************************************************************** *)


interface

{Nicht mde werden,
nicht mde werden
sondern dem Wunder
wie einem Vogel
die Hand hinhalten.}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Grids, Menus,
  uMaliste,                       //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  uMitarbeiter,
  uPool,
  uSchicht,
  uTag,
  uWoche,
  uInfoBox;

const End_Frueh = 13;
      End_Spaet = 26;
type
  TFensterFrm = class(TForm)
    Personaldaten: TTabSheet;
    Einsatzplan: TTabSheet;
    KennungGroupBox: TGroupBox;
    PersnrPnl: TPanel;
    VornPnl: TPanel;
    NachnPnl: TPanel;
    PersnrEdt: TEdit;
    VornEdt: TEdit;
    NachnEdt: TEdit;
    AdresseGroupBox: TGroupBox;
    StrassePnl: TPanel;
    PlzPnl: TPanel;
    OrtPnl: TPanel;
    TelPnl: TPanel;
    PlzEdt: TEdit;
    OrtEdt: TEdit;
    TelEdt: TEdit;
    StrasseEdt: TEdit;
    MitLBox: TListBox;
    MANeuBtn: TButton;
    Datenblaetter: TPageControl;
    SpeichernBtn: TButton;
    LoeschenBtn: TButton;
    VerfuegbarkeitRadioGroup: TRadioGroup;
    ArbeitsplatzRadioGroup: TRadioGroup;
    SchichtRadioGroup: TRadioGroup;
    VerfuegbarCbox: TCheckBox;
    FreiCbox: TCheckBox;
    fehltcbox: TCheckBox;
    UrlaubCbox: TCheckBox;
    FruehCbox: TCheckBox;
    SpaetCbox: TCheckBox;
    SpueleCbox: TCheckBox;
    BueffetCBox: TCheckBox;
    KuecheCBox: TCheckBox;
    GroupBox1: TGroupBox;
    MontagCbox: TCheckBox;
    DienstagCbox: TCheckBox;
    MittwochCbox: TCheckBox;
    DonnerstagCbox: TCheckBox;
    FreitagCbox: TCheckBox;
    SamstagCbox: TCheckBox;
    GroupBox2: TGroupBox;
    IststundenLbl: TLabel;
    IststundenEdt: TEdit;
    SollstundenLbl: TLabel;
    SollstundenEdt: TEdit;
    AendernBtn: TButton;
    StringGrid1: TStringGrid;
    meldelbl: TLabel;
    LBoxA: TButton;
    BerechnenBtn: TButton;
    InitBtn: TButton;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Laden1: TMenuItem;
    Speichern1: TMenuItem;
    N1: TMenuItem;
    Beenden1: TMenuItem;
    Info1: TMenuItem;
    OpenDialog: TOpenDialog;
    StatusBar: TStatusBar;
    LadenBtn: TButton;
    SuchenBtn: TButton;
    AktualisierenBtn: TButton;
    Arbeitsplaetze: TTabSheet;
    APCombo: TComboBox;
    APNeuBtn: TButton;
    APList: TListBox;
    APListAktualisierenBtn: TButton;
    Anzeigen1: TMenuItem;
    Mitarbeiterliste1: TMenuItem;
    Besetzungsliste1: TMenuItem;
    Arbeitsplatzliste1: TMenuItem;
    TageCombo: TComboBox;
    WhoDunnit1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure MANeuBtnClick(Sender: TObject);
    procedure SpeichernBtnClick(Sender: TObject);
    procedure LoeschenBtnClick(Sender: TObject);
    procedure AendernBtnClick(Sender: TObject);
    procedure LBoxAClick(Sender: TObject);
    procedure BerechnenBtnClick(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure MitLBoxClick(Sender: TObject);
    procedure InitBtnClick(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Speichern1Click(Sender: TObject);
    procedure LadenBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AktualisierenBtnClick(Sender: TObject);
    procedure APNeuBtnClick(Sender: TObject);
    procedure APListAktualisierenBtnClick(Sender: TObject);
    procedure Mitarbeiterliste1Click(Sender: TObject);
    procedure Besetzungsliste1Click(Sender: TObject);
    procedure Arbeitsplatzliste1Click(Sender: TObject);
    procedure TageComboChange(Sender: TObject);
    procedure WhoDunnit1Click(Sender: TObject);

  private
      AktMA : TMitarbeiter;                 // aktueller Mitarbeiter
      Mitliste   : TMAListe;
      Tag : TTag;
      Woche : TWoche;

      procedure Init;
      procedure DatenAktualisieren (var mit : TMitarbeiter);  virtual;
      procedure MaskeAktualisieren (mit : TMitarbeiter);      virtual;
      procedure MitLBoxAktualisieren;                         virtual;
      procedure EinsatzMaskeAktualisieren;
      procedure APMaskeAktualisieren;
    procedure Planerstellen;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FensterFrm: TFensterFrm;
  
(* -------------------- B e s c h r e i b u n g -------------------------

Oberklasse    : TForm
Bezugsklassen : TMAListe, TMitarbeiter, GUI-Klassen


Methoden
--------

Init
  Auftrag: alle GUI-Felder leeren;
  vorher : -
  nachher: -

NeuBtnClick
  Auftrag: Maske leeren fr die Eingaben eines neuen Mitarbeiter.
           Die Daten werden verarbeitet, wenn Speichern, ndern oder
           Lschen gedrckt ist.
  nachher: Maske ist leer

AendernBtnClick
  Auftrag: Die in die Maske eingetragenen Daten als nderung bernehmen.
  vorher : Liste ist nicht leer
  nachher: Mitarbeiter ist in die Liste zurueckgeschrieben. Maske ist leer.

LoeschBtnClick
  Auftrag: Aktuellen Mitarbeiter loeschen nach Rckfrage.
  vorher : Liste ist nicht leer. Der zu lschenden Mitarbeiter wurde gefunden.
           Maske ist leer.
  nachher: Mitarbeiter ist aus der Liste entfernt

EndeBtnClick
  Auftrag: Programm beenden, Fenster schlieen, Daten speichern
  vorher : -
  nachher: Daten gespeichert, Programm beendet

SpeichernBtnClick
  Auftrag: Aktueller Mitarbeiter aus der Maske uebernehmen. Es kann solange
           editiert werden, bis Speichern geklickt ist. Ist der Name leer, wird kein
           Eintrag erzeugt.
  vorher : -
  nachher: Aktueller Mitarbeiter ist uebernommen.

MaskeAktualisieren (mit : TMitarbeiter)
  Auftrag: Attributwerte des aktuellen Mitarbeiter in die GUI-Maske bernehmen
  vorher : mit ist vorhanden, sonst bleibt Maske leer.
  nachher: Feldinhalte werden in der Maske angezeigt.

DatenAktualisieren (var  : TMitarbeiter);
  Auftrag: Inhalte aller Felder der GUI-Maske an den aktuellen Mitarbeiter
           uebergeben.
  vorher : Mitarbeiter ist initialisiert.
  nachher: alle Masken-Inhalte sind an den aktuellen Mitarbeiter uebergeben.

MitBoxAktualisieren
  Auftrag: Aktuelle Liste in der MitLBox anzeigen und Auswhlen durch Anklicken
  vorher : Objekt ist vorhanden, sonst bleibt Maske leer.
  nachher: Items werden in der Maske angezeigt.

----------------------------------------------------------------------- *)

implementation
{$R *.DFM}
(*===========================================================================*)

procedure TFensterFrm.FormCreate(Sender: TObject);
(* ------------------------------------------------------------------- *)
var i:integer;
begin
  AktMa := TMitarbeiter.Create;
  Mitliste := TMAListe.Create;
  Tag := TTag.Create(1, '1.1.00', 'Bffet', End_Frueh, End_Spaet);
  woche := TWoche.Create(1, 'Bffet', End_Frueh, End_Spaet);
  woche.NeuerArbeitsplatz('Bffet',End_Frueh, End_Spaet);
  woche.NeuerArbeitsplatz('Kche',End_Frueh, End_Spaet);
  woche.NeuerArbeitsplatz('Sple',End_Frueh, End_Spaet);
  tag := woche.tage[1];
  Mitliste.Load(OpenDialog.Filename);
  MitLBoxAktualisieren;
  // fr den Einsatzplan
  StringGrid1.ColCount:=3;
  Stringgrid1.RowCount := End_spaet+1;
     with StringGrid1 do
     begin
          Cells[0,0]:='Zeit';
          Cells[1,0]:='Block';

          Cells[0,1]:='7:30'; Cells[0,2]:='8:00'; Cells[0,3]:='8:30';
          Cells[0,4]:='9:00'; Cells[0,5]:='9:30'; Cells[0,6]:='10:00';
          Cells[0,7]:='10:30'; Cells[0,8]:='11:00'; Cells[0,9]:='11:30';
          Cells[0,10]:='12:30'; Cells[0,11]:='13:00'; Cells[0,12]:='13:30';
          Cells[0,13]:='14:00'; Cells[0,14]:='14:30'; Cells[0,15]:='15:00';
          Cells[0,16]:='15:30'; Cells[0,17]:='16:00'; Cells[0,18]:='16:30';
          Cells[0,19]:='17:00'; Cells[0,20]:='17:30'; Cells[0,21]:='18:00';
          Cells[0,22]:='18:30'; Cells[0,23]:='19:00'; Cells[0,24]:='19:30';
          Cells[0,25]:='20:00'; Cells[0,26]:='20:30';

          For i:=1 to End_spaet+1 do Cells[1,i]:=inttostr(i);
     end;

     Init;
     APCombo.ItemIndex := 0;
     TageCombo.ItemIndex := 0;
end;


procedure TFensterFrm.Init;
(* -------------------------------------------------------------------- *)
begin
  NachnEdt.Text      := '';
  PersnrEdt.Text     := '';
  VornEdt.Text       := '';
  StrasseEdt.Text    := '';
  PlzEdt.Text        := '';
  OrtEdt.Text        := '';
  TelEdt.Text        := '';
  IststundenEdt.Text := '0';


  VerfuegbarCbox.Checked   := true;
  FreiCbox.Checked         := false;
  fehltCbox.Checked        := false;
  UrlaubCbox.Checked       := false;
  FruehCbox.Checked        := true;
  SpaetCbox.Checked        := true;
  SpueleCbox.Checked       := true;
  BueffetCBox.Checked      := true;
  KuecheCBox.Checked       := true;
  MontagCbox.Checked       := true;
  DienstagCbox.Checked     := true;
  MittwochCbox.Checked     := true;
  DonnerstagCbox.Checked   := true;
  FreitagCbox.Checked      := true;
  SamstagCbox.Checked      := true;

  meldelbl.caption:= '';
end;

procedure TFensterFrm.DatenAktualisieren (var mit : TMitarbeiter);
(* ------------------------------------------------------------------- *)
begin
    Mit.SetName (NachnEdt.Text);
    Mit.SetVorName (VornEdt.Text);
    Mit.SetPersnr (strtoint(PersnrEdt.Text));
    Mit.SetMontag (montagCbox.checked);
    Mit.SetDienstag (dienstagCbox.checked);
    Mit.SetMittwoch (mittwochCbox.checked);
    Mit.SetDonnerstag (donnerstagCbox.checked);
    Mit.SetFreitag (freitagCbox.checked);
    Mit.SetSamstag (samstagCbox.checked);
    Mit.Setspaet(spaetCbox.Checked);
    Mit.SetFrueh (fruehcbox.checked);
    Mit.SetKueche (kuechecbox.checked);
    if freiCbox.checked or urlaubCbox.checked or fehltCbox.checked
    then Mit.SetStatus(1)                     // NN: erstmal irgendwas, damit Status != 0, sollte verbessert werden
    else Mit.SetStatus(0);
    Mit.SetIststunden(strtoint(iststundenedt.text));
    Mit.SetSollstunden(strtoint(sollstundenedt.text));
    Mit.SetSpuele(spueleCbox.checked);
    Mit.SetBueffet(bueffetCbox.checked);
 //   Mit.Setfrei(freiCbox.checked);
 //   Mit.SetUrlaub(urlaubCbox.checked);
 //   Mit.Setfehlt(fehltCbox.checked);
    Mit.Adresse.SetStrasse(StrasseEdt.Text);
    Mit.Adresse.SetPlz (PlzEdt.Text);
    Mit.Adresse.SetOrt (OrtEdt.Text);
//    Mit.Adresse.SetTelefon (TelEdt.Text);

end;


procedure TFensterFrm.MaskeAktualisieren (mit : TMitarbeiter);
(* ------------------------------------------------------------------- *)
begin
  with  mit do
  begin
    nachnEdt.Text          := GetName;
    vornEdt.Text           := GetVorName ;
    PersnrEdt.Text         := inttostr(GetPersnr);
    montagCbox.checked     := GetMontag;
    dienstagCbox.checked   := GetDienstag;
    MittwochCbox.checked   := GetMittwoch;
    DonnerstagCbox.checked := GetDonnerstag;
    FreitagCbox.checked    := GetFreitag;
    SamstagCbox.checked    := GetSamstag;
    SpaetCbox.checked      := Getspaet;
    FruehCbox.checked      := Getfrueh;
    KuecheCbox.checked     := GetKueche;
 //   VerfuegbarCbox.checked := GetVerfuegbar;   //<<<<<<<<<<<<<<<<<<<<<<<<<<
//    freiCbox.checked       := GetFrei;
//    UrlaubCbox.checked     := GetUrlaub;
//    fehltCbox.checked      := Getfehlt;
    Iststundenedt.text     := floattostr(GetIststunden);
    Sollstundenedt.text    := floattostr(Getsollstunden);
    SpueleCbox.checked     := GetSpuele;
    BueffetCbox.checked    := GetBueffet;
    StrasseEdt.Text        := Adresse.GetStrasse;
    PlzEdt.Text            := Adresse.GetPlz ;
    OrtEdt.Text            := Adresse.GetOrt;
 //   TelEdt.Text            := Adresse.GetTelefon;
   end;
end;



procedure TFensterFrm.MitLBoxAktualisieren;
(* ------------------------------------------------------------------- *)
var zeile : string;
begin
  if  NOT Mitliste.Isempty then
  begin
  MitLbox.clear;
  Mitliste.First;
  while NOT Mitliste.EoList do
  begin
    AktMA := Mitliste.GetElement;
    zeile := Format('%-13s %-12s',[AktMA.GetName,AktMA.GetVorname]);
    MitLbox.Items.Add(zeile);
    Mitliste.Next;
  end;
  Mitliste.First
  end;
end;

procedure TFensterFrm.EinsatzMaskeAktualisieren;
(* -------------------------------------------------------------------- *)
var schicht : TSchicht;
    ma : TMitarbeiter;
    for_schichten, for_schicht, cells_x, cells_y  :integer;
    s : string;
    spaet : boolean;            // NN: wird gerade eine Frh- oder Sptschicht behandelt?
begin
     schicht := TSchicht.create('',0,10,0);
     ma := TMitarbeiter.create;
     tag.schichten.First;
     cells_x := 2; cells_y := 1;
     spaet := false;
     StringGrid1.ColCount:= 2+round((tag.Schichten.getlen)/2);
     for for_schichten := 1 to tag.schichten.getlen do
     begin
          schicht := tag.schichten.getelement;
          if schicht.Besetzung.IsEmpty then
          begin
               for for_schicht := 1 to End_Spaet- End_Frueh do
                   begin
                        s := '??';
                        StringGrid1.Cells[cells_x,cells_y] := s;
                        inc(cells_y);
                   end;
          end
          else
          begin
               schicht.Besetzung.First;
               for for_schicht := 1 to schicht.Besetzung.getlen do
                   begin
                        s := '';
                        ma := schicht.Besetzung.GetElement;
                        s:= ma.GetName +', '+ ma.getVorname+ ' ('+IntToSTr(ma.getPersnr)+')';
                        StringGrid1.Cells[cells_x,cells_y] := s;
                        inc(cells_y);
                        schicht.Besetzung.Next;
                   end;
          end;
          if spaet then begin inc(cells_x); cells_y := 1; end
          else StringGrid1.Cells[cells_x,0] := schicht.GetArbeitsplatz;

          if not tag.Schichten.EoList then tag.Schichten.Next
          else ShowMessage('EoList');

          spaet := not spaet;
     end;
end;

procedure TFensterFrm.APMaskeAktualisieren;
(* -------------------------------------------------------------------- *)
var s : string;
    for_schichten : integer;
    schicht : TSchicht;
    spaet : boolean;
begin
     schicht := TSchicht.create('',0,10,0);
     tag.schichten.First;
     spaet := false;
     APList.Clear;

     for for_schichten := 1 to tag.schichten.getlen-1 do
     begin
          schicht := tag.schichten.getelement;

          if not spaet then APList.Items.Add(schicht.GetArbeitsplatz);

          if not tag.Schichten.EoList then tag.Schichten.Next
          else ShowMessage('EoList');

          spaet := not spaet;
     end;
end;

procedure TFensterFrm.MANeuBtnClick(Sender: TObject);
(* ------------------------------------------------------------------- *)
var ma : TMitarbeiter;
begin
     if PersnrEdt.Text = '' then ShowMessage('Bitte Personalnummber eingeben')
     else
     begin
     ma := TMitarbeiter.Create;
     DatenAktualisieren(ma);
     MitListe.Append(ma);
     Init;
     MitLBoxAktualisieren;
     StatusBar.SimpleText := 'Mitarbeiter: '+ma.getName+ ' in die Liste bernommen';
     end;
end;

procedure TFensterFrm.SpeichernBtnClick(Sender: TObject);
(* ------------------------------------------------------------------- *)
var NeuerMitarbeiter : TMitarbeiter;

begin
     if (NachnEdt.Text <> '')and (PersnrEdt.Text <> '')
     then
     begin
          NeuerMitarbeiter := TMitarbeiter.Create;  // neues Exemplar muss in die Liste
          Datenaktualisieren(NeuerMitarbeiter);
          Mitliste.Append(NeuerMitarbeiter);
          Init;
          MitLBoxAktualisieren;
     end;
     MitListe.Store(OpenDialog.Filename);
     StatusBar.SimpleText :='Mitarbeiterliste in '+OpenDialog.Filename+' gespeichert';
end;


procedure TFensterFrm.LoeschenBtnClick(Sender: TObject);
(* ------------------------------------------------------------------- *)
var AbfrageErgebnis : integer;

begin
 if Mitliste.IsEmpty
  then StatusBar.SimpleText := ' Keine Eintrge vorhanden'
  else
    begin
      beep;
      AbfrageErgebnis := Application.MessageBox('Wollen Sie wirklich lschen ?', '',MB_ICONWARNING + MB_YESNO);
      case AbfrageErgebnis of
        IDYES : begin
                  Mitliste.Remove;
                  Init;
                  MitLBoxAktualisieren;
                end;
      end;
    end;
end;

procedure TFensterFrm.AendernBtnClick(Sender: TObject);
(* ------------------------------------------------------------------- *)
begin
  if Mitliste.IsEmpty
  then StatusBar.SimpleText := ' Keine Eintrge vorhanden'
  else
    begin
      Datenaktualisieren (AktMA);
      Mitliste.PutElement(AktMA);
      MitLBoxAktualisieren;
    end;
  MaskeAktualisieren(aktMA);
end;


procedure TFensterFrm.LBoxAClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     if  DatenBlaetter.ActivePage <> Personaldaten then
        DatenBlaetter.ActivePage := Personaldaten;
     MitLBoxAktualisieren;
end;


procedure TFensterFrm.BerechnenBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
 planerstellen;
end;

procedure TFensterFrm.Planerstellen;
(* -------------------------------------------------------------------- *)
begin
     if woche.Besetzen(MitListe) then StatusBar.Simpletext := 'Alle Schichten erfolgreich besetzt'
     else StatusBar.Simpletext := 'Es konnten nicht alle Schichten besetzt werden';
     EinsatzmaskeAktualisieren;
end;


procedure TFensterFrm.StringGrid1Click(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
// planerstellen;
end;

procedure TFensterFrm.MitLBoxClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
var i, pos : integer;
begin
     pos := MitLBox.ItemIndex;
     MitListe.First;
     for i:=1 to pos do
          MitListe.Next;

     aktma := MitListe.GetElement;
     MaskeAktualisieren(aktma);
end;

procedure TFensterFrm.InitBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     Init;
end;

procedure TFensterFrm.Beenden1Click(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     Close;
end;

procedure TFensterFrm.Speichern1Click(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     SpeichernBtnClick(Sender);
end;

procedure TFensterFrm.LadenBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     if OpenDialog.Execute then
     begin
          MitListe.Load(OpenDialog.Filename);
          StatusBar.SimpleText := 'Mitarbeiterliste aus '+OpenDialog.Filename+' geladen';
     end;
end;

procedure TFensterFrm.FormClose(Sender: TObject; var Action: TCloseAction);
(* -------------------------------------------------------------------- *)
begin
     woche.Free;
     tag := nil;
     aktma.Free;
     MitListe.Free;
end;

procedure TFensterFrm.AktualisierenBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     if  DatenBlaetter.ActivePage <> Einsatzplan then
        DatenBlaetter.ActivePage := Einsatzplan;

     EinsatzmaskeAktualisieren;
end;

procedure TFensterFrm.APNeuBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     woche.NeuerArbeitsplatz(APCombo.Items[APcombo.ItemIndex],End_Frueh, End_Spaet);
     APMaskeAktualisieren;
end;

procedure TFensterFrm.APListAktualisierenBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin

     APMaskeAktualisieren;
end;

procedure TFensterFrm.Mitarbeiterliste1Click(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     DatenBlaetter.ActivePage := Personaldaten;
     MitLBoxAktualisieren; 
end;

procedure TFensterFrm.Besetzungsliste1Click(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     DatenBlaetter.ActivePage := Einsatzplan;
     EinsatzmaskeAktualisieren;
end;

procedure TFensterFrm.Arbeitsplatzliste1Click(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     DatenBlaetter.ActivePage := Arbeitsplaetze;
     APMaskeAktualisieren;
end;

procedure TFensterFrm.TageComboChange(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
     tag := woche.tage[TageCombo.ItemIndex+1];
     EinsatzmaskeAktualisieren;
end;


procedure TFensterFrm.WhoDunnit1Click(Sender: TObject);
begin
  Infobox.Show;
end;

end.
